package org.astakhova.test;

import java.io.StringReader;

import org.astakhova.data.*;
import junit.framework.TestCase;

public class JTestModel extends TestCase {
	public void testDiagram1() {
		IDiagram d = DiagramFactory.newDiagram();
		d.createDataNode(0, 0);
		compare(d.toString() + "\n", "test/model/test1.txt");
	}
	
	public void testDiagram2() {
		IDiagram d = DiagramFactory.newDiagram();
		INode n0 = d.createDataNode(0, 0);
		INode n1 = d.createDataNode(1, 1);
		compare(d.createArrow(n0, n1).toString() + "\n", "test/model/test2.txt");
	}
	
	public void testDiagram3() {
		IDiagram d = DiagramFactory.newDiagram();
		INode n0 = d.createDataNode(0, 0);		
		INode n1 = d.createDataNode(1, 1);
		String ss = d.createArrow(n0, n1).toString() + "\n";
		ss += d + "\n";
		ss += d.createArrow(n0, n1) + "\n";
		compare(ss, "test/model/test3.txt");
	}
	
	public void testDiagram4() {
		IDiagram d = DiagramFactory.newDiagram();
		d.createDataNode(0, 0);
		INode n = d.getNode(0, 0);
		n.setText("A");
		String s = n.getText() + "\n";
		s += n.getX() + "\n";
		s += n.getY() + "\n";
		compare(s, "test/model/test4.txt");
	}
	
	public void testDiagram5() {
		IDiagram d = DiagramFactory.newDiagram();
		INode n0 = d.createDataNode(0, 0);
		INode n1 = d.createDataNode(1, 1);
		IArrow a = d.createArrow(n0, n1);
		d.removeArrow(a);
		compare(d.toString() + "\n", "test/model/test5.txt");
	}
	
	public void testDiagram6() {
		IDiagram d = DiagramFactory.newDiagram();
		d.createDataNode(0, 0);
		d.getNode(0, 0).setText("A");
		d.createDataNode(1, 1);
		d.getNode(1, 1).setText("B");
		String s = "";
		for (INode n : d.getNodes())
			s += n.toString() + "\n";
		compare(s, "test/model/test6.txt");
	}
	
	public void testDiagram7() {
		IDiagram d = DiagramFactory.newDiagram();
		d.createDataNode(0, 0);
		d.getNode(0, 0).setText("A");
		d.createDataNode(1, 1);
		d.removeNode(d.getNode(1, 1));
		compare(d.toString() + "\n", "test/model/test7.txt");
	}
	
	public void testDiagram8() {
		IDiagram d = DiagramFactory.newDiagram();
		d.createCondNode(0, 0);
		d.getNode(0, 0).setText("A");
		d.createDataNode(1, 1);
		d.getNode(1, 1).setText("B");
		d.createArrow((IConditionNode) d.getNode(0, 0), 
				d.getNode(1, 1), true);
		d.createArrow((IConditionNode)d.getNode(0, 0), 
				d.getNode(1, 1), false);
		compare(d.toString() + "\n", "test/model/test8.txt");
	}
	
	public void testDiagram9() {
		IDiagram d = DiagramFactory.newDiagram();
		d.createDataNode(0, 0);
		d.getNode(0, 0).setText("A");
		d.createDataNode(1, 1);
		d.getNode(1, 1).setText("B");
		d.createDataNode(2, 2);
		d.getNode(2, 2).setText("C");
		IArrow a = d.createArrow(d.getNode(0, 0), d.getNode(1, 1));
		a.setDest(d.getNode(2, 2));
		compare(d.toString() + "\n", "test/model/test9.txt");
	}
	
	public void testDiagram10() {
		IDiagram d = DiagramFactory.newDiagram();
		d.createCondNode(0, 0);
		d.getNode(0, 0).setText("A");
		d.removeNode(d.getNode(0, 0));
		compare(d.toString(), "test/model/test10.txt");
	}
	
	private void compare(String diagram, String pattern) {
		try {
			//Forms pattern files 			
			/*java.io.FileWriter fw = new java.io.FileWriter(pattern);
			fw.write(diagram);
			fw.close();*/
			
			StringReader sr = new StringReader(diagram);
			java.io.FileReader fr = 
				new java.io.FileReader(pattern);
			int a, b;
			while (((a = sr.read()) >= 0) && ((b = fr.read()) >= 0))
				assertEquals(a, b);
			sr.close();
			fr.close();
		} catch(Exception e) {
			throw new RuntimeException();
		}
	}
}
