package org.astakhova.view;

import javax.swing.*;
import java.awt.*;
import javax.swing.plaf.basic.*;

/**
 * Makes a description of the diagram selection box
 * @author Astakhova Julia A.
 *
 */
public class CPBox extends JComponent {
	static final long serialVersionUID = 1;
	private Rectangle myParameters;
	private Point myPoint;
	
	/**
	 * Creates a new diagram selection box
	 * @param x x-coordinate
	 * @param y y-coordinate
	 * @param w width
	 * @param h height
	 */
	public CPBox(int x, int y, int w, int h) {
		myParameters = new Rectangle(x, y, w, h);
		myPoint = new Point(x, y);
		setSize(1000, 1000);
	}
	
	public void paint(Graphics g) {
		super.paint(g);
		Graphics2D g2 = (Graphics2D) g;
		g2.setStroke(new BasicStroke(1f));
		BasicGraphicsUtils.drawDashedRect(g2, myParameters.x, myParameters.y, 
				myParameters.width, myParameters.height);	
	}
	
	/**
	 * Sets a new parameters
	 * @param x x-coordinate
	 * @param y y-coordinate
	 * @param w width
	 * @param h height
	 */
	public void setParameters(int x, int y, int w, int h) {
		myParameters.x = x;
		myParameters.y = y;
		myParameters.width = w;
		myParameters.height = h;
	}
	
	public Rectangle getParameters() {
		return myParameters;
	}
	
	public Point getPoint() {
		return myPoint;
	}
}
