package org.astakhova.view;

import javax.swing.*;
import java.io.FileWriter;
import java.io.IOException;

/**
 * Information error form
 * @author Astakhova Julia A.
 */
public class ErrorForm {
	private static final String myWarning = 
		"It's better to close the application";
	private static final String myPath = 
		"The error description can be found at \\bde.log";
	private static final String myFile = "bde.log";
	
	/**
	 * Creates a new error form
	 * @param mf owner
	 * @param e exception caused the error
	 * @param description error description
	 * @param warning if it's necessary to end the application
	 */
	public ErrorForm(MainForm mf, Exception e, 
			String description, boolean warning) {
		String message = description;
		if (e != null) {
			message += "\n" + myPath;
			try {
				FileWriter fw =  new FileWriter(myFile);
				fw.write(e.getMessage());
				fw.close();
			} catch (IOException ioe) {}
		}
		if (warning)
			message += myWarning;
		JOptionPane.showMessageDialog(mf, message, 
				"Error", JOptionPane.ERROR_MESSAGE);
	}
}
