package org.astakhova.view;

import java.awt.Component;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.JTextField;

/**
 * Makes a description of the link label edit key listener
 * @author Astakhova Julia A.
 */
public class LinkLabelEditL extends KeyAdapter {
	private DiagramForm myForm;
	
	/**
	 * Creates a new link label edit key listener
	 * @param df owner of the link containing the label
	 */
	public LinkLabelEditL(DiagramForm df) {
		myForm = df;
	}
	
	public void keyPressed(KeyEvent ke) {
		JTextField jtf = null;
		ConditionLink cl = null; 
		
		for (Component o : myForm.getContentPane().getComponents())
			if (o instanceof ConditionLink 
					&& ((ConditionLink) o).getEditableComponent() != null) {
				cl = (ConditionLink) o;
				jtf = cl.getEditableComponent();
				break;
			}
		
		if (jtf == null)
			return;
		
		if (ke.getKeyCode() == KeyEvent.VK_ENTER) {
			String s = jtf.getText();
			String ss = cl.getArrow().getLabel();
			cl.getArrow().setLabel(s);
			myForm.getContentPane().remove(jtf);
			cl.setEditableComponent(null);
			if (!s.equals(ss))
				myForm.fixChanges();
			myForm.repaint();
		}
		
		if (ke.getKeyCode() == KeyEvent.VK_ESCAPE) {
			myForm.getContentPane().remove(jtf);
			cl.setEditableComponent(null);
			myForm.repaint();
		}
	}
}
