package org.astakhova.view;

import java.util.*;
import org.astakhova.view.param.SColor;
import java.awt.*;

public class SetOfSelectedItems {
	//First - sourceblock, Second - targetblock
	private LinkedList<Block> myBlockList =
		new LinkedList<Block>();
	private LinkedList<Line> myArrowList = 
		new LinkedList<Line>();
	private Boolean myPart;
	
	public void setSelected(Color c) {
		if (myPart == null)
			for (Block b : myBlockList)
				if (b != null)
					b.setSelected(c);
		for (Line l : myArrowList)
			l.setSelected(c);
		if ((myPart != null) && (myBlockList.size() > 0) && 
				myBlockList.get(0) instanceof ConditionBlock) {
			((ConditionBlock) myBlockList.get(0)).setSelected(c, myPart);
			if (myBlockList.size() > 1)
				myBlockList.get(1).setSelected(c);
		}
	}
	
	public void addBlock(Block b) {
		myBlockList.add(b);
	}
	
	public void addCondBlock(ConditionBlock b, Boolean p) {
		myBlockList.add(b);
		myPart = p;
	}
	
	public void removeBlock(Block b) {
		myBlockList.remove(b);
		b.setSelected(SColor.usual());
	}
	
	public java.util.List<Block> getBlockList() {
		return Collections.unmodifiableList(myBlockList);
	}
	
	public void clear() {
		//When conditionNode is connected to another and mouse is released
		/*for 
			getBlock().setSelected(SColor.usual());*/
		
		setSelected(SColor.usual());
		myBlockList.clear();
		myArrowList.clear();
		myPart = null;
	}
	
	public java.util.List<Line> getLineList() {
		return Collections.unmodifiableList(myArrowList);
	}
	
	public void addLink(Line l) {
		myArrowList.add(l);
	}
	
	public void removeLink(Line l) {
		myArrowList.remove(l);
		l.setSelected(SColor.usual());
	}
	
	public Boolean getPart() {
		return myPart;
	}	
	
	public Component[] getComponents() {
		LinkedList<Component> components = new LinkedList<Component>();
		for (Block b : myBlockList)
			if (b != null)
				components.add(b);
		for (Line l : myArrowList)
			components.add(l);
		return components.toArray(new Component[components.size()]);
	}
}
